/*
 * Program compared to applet found at http://webpages.ull.es/users/jriera/Docencia/AVL/AVL%20tree%20applet.htm
 */
#include <iostream>
#include "AVL_Tree.h"
using namespace std;

int main()
{
   cout << "Entering main()" << endl;
   {
      /* LL - single_rotation_with_left_child test */
      AVL_Tree<int> avl_tree;

      cout << "Performing LL-test." << endl;
      cout << "Should perform single_rotate_with_left_child." << endl;
      /* Applet: 50 rotated right */

      cout << "Inserting 50, 22, 75, 80, 43, 15, 9." << endl;
      avl_tree.insert(50);
      avl_tree.insert(22);
      avl_tree.insert(75);
      avl_tree.insert(80);
      avl_tree.insert(43);
      avl_tree.insert(15);
      avl_tree.insert(9);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cout << "Removing 80." << endl;
      avl_tree.remove(80);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cin.get();
   }
   {
      /* LR - double_rotation_with_left_child test */
      AVL_Tree<int> avl_tree;

      cout << "Performing LR-rest." << endl;
      cout << "Should perform double_rotate_with_left_child." << endl;
      /* Applet: 22 rotated left, 50 rotated right */

      cout << "Inserting 50, 22, 75, 80, 43, 15, 28." << endl;
      avl_tree.insert(50);
      avl_tree.insert(22);
      avl_tree.insert(75);
      avl_tree.insert(80);
      avl_tree.insert(43);
      avl_tree.insert(15);
      avl_tree.insert(28);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cout << "Removing 80." << endl;
      avl_tree.remove(80);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cin.get();
   }
   {
      /* RR - single_rotation_with_right_child test */
      AVL_Tree<int> avl_tree;

      cout << "Performing RR-test." << endl;
      cout << "Should perform single_rotate_with_right_child." << endl;
      /* Applet: 50 rotated left */

      cout << "Inserting 50, 35, 75, 25, 65, 85, 95." << endl;
      avl_tree.insert(50);
      avl_tree.insert(35);
      avl_tree.insert(75);
      avl_tree.insert(25);
      avl_tree.insert(65);
      avl_tree.insert(85);
      avl_tree.insert(95);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cout << "Removing 25." << endl;
      avl_tree.remove(25);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cin.get();
   }
   {
      /* RL - double_rotation_with_right_child test */
      AVL_Tree<int> avl_tree;

      cout << "Performing RL-test." << endl;
      cout << "Should perform double_rotate_with_right_child." << endl;
      /* Applet: 75 rotated right, 50 rotated left */

      cout << "Inserting 50, 25, 75, 15, 65, 80, 70." << endl;
      avl_tree.insert(50);
      avl_tree.insert(25);
      avl_tree.insert(75);
      avl_tree.insert(15);
      avl_tree.insert(65);
      avl_tree.insert(80);
      avl_tree.insert(70);

      avl_tree.print_tree(cout);

      cout << endl << endl;

      cout << "Removing 15." << endl;
      avl_tree.remove(15);

      avl_tree.print_tree(cout);

      cin.get();
   }

#if 0
  for (int i = 1; i <= 11; i++)
    avl_tree.insert(i);

  try 
  {
     cout << "AVL-trd efter insttning av 1, 2,..., 11:\n\n";
     avl_tree.print_tree(cout);
     cout << endl;
  }
  catch (const exception& e) 
  {
     cout << '\n' << e.what() << endl;
     cout << "AVL-trd innehller efter insttning av 1, 2,..., 11:\n\n";
     avl_tree.print(cout);
     cout << endl;
  }

  unsigned int  choise;
  unsigned int  value;

  while (true) 
  {
    cout << endl;
    cout << "1 - Stt in.\n";
    cout << "2 - Ta bort.\n";
    cout << "3 - Sk vrde.\n";
    cout << "4 - Sk minsta.\n";
    cout << "5 - Sk strsta.\n";
    cout << "6 - Tm trdet.\n";
    cout << "7 - Skriv ut ordnat.\n";
    cout << "8 - Skriv ut trd.\n";
    cout << "0 - Avsluta.\n" << endl;
    cout << "Val: ";
    cin >> choise;
    cout << endl;

    try 
    {
       switch (choise) 
       {
	  case 0:
	     cout << "Slut." << endl;
	     return 0;
	  case 1:
	     cout << "Vrde att stta in: ";
	     cin >> value;
	     avl_tree.insert(value);
	     break;
	  case 2:
	     cout << "Vrde att ta bort: ";
	     cin >> value;
	     avl_tree.remove(value);
	     break;
	  case 3:
             cout << "Vrde att ska efter: ";
	     cin >> value;
	     if (avl_tree.member(value))
		cout << "Vrdet " << value << " finns i trdet." << endl;
	     else
		cout << "Vrdet " << value << " finns ej i trdet." << endl;
	     break;
	  case 4:
	     if (avl_tree.empty())
		cout << "Trdet r tomt!" << endl;
	     else
		cout << "Minsta vrdet i trdet r " << avl_tree.find_min() << endl;
	     break;
	  case 5:
	     if (avl_tree.empty())
		cout << "Trdet r tomt!" << endl;
	     else
		cout << "Strsta vrdet i trdet r " << avl_tree.find_max() << endl;
	     break;
	  case 6:
	     /* Detta borde frsts bekrftas! */
	     avl_tree.clear();
	     cout << "Trdet r tmt!" << endl;
	     break;
	  case 7:
	     if (avl_tree.empty()) 
	     {
		cout << "Trdet r tomt!" << endl;
	     }
	     else 
	     {
		avl_tree.print(cout);
		cout << endl;
	     }
	     break;
	  case 8:
	     if (avl_tree.empty()) 
	     {
		cout << "Trdet r tomt!" << endl;
	     }
	     else 
	     {
		avl_tree.print_tree(cout);
		cout << endl;
	     }
	     break;
	  default:
	     cout << "Felaktigt val!" << '\b' << endl;
	     break;
       }
    }
    catch (const exception& e) 
    {
       cout << e.what() << endl; 
    }
    catch (...) 
    {
       cout << "Ett oknt fel har intrffat." << endl; 
    }
  }
#endif
  return 0;
}
